Package uk.ac.starlink.util.gui

# Class SelectTextField

java.lang.Object
java.awt.Component
java.awt.Container
javax.swing.JComponent
javax.swing.JPanel
uk.ac.starlink.util.gui.SelectTextField

All Implemented Interfaces:
  `ImageObserver`, `MenuContainer`, `Serializable`, `EventListener`, `Accessible`, `SelectCharactersListener`

public class SelectTextField extends JPanel implements SelectCharactersListener
A component for accepting a text string, but with the additional capability of choosing from the complete list of characters available in the current font. The font details are shown in a popup window that is initialised using a button shown against the text entry area.

Since:
  $Date$, 06-NOV-2000
Version:
  $Id$
Author:
  Peter W. Draper
See Also:
  - Serialized Form

## Nested Class Summary

## Nested classes/interfaces inherited from class javax.swing.JPanel

`JPanel.AccessibleJPanel`

## Nested classes/interfaces inherited from class javax.swing.JComponent

`JComponent.AccessibleJComponent`

## Nested classes/interfaces inherited from class java.awt.Container

`Container.AccessibleAWTContainer`

## Nested classes/interfaces inherited from class java.awt.Component

`Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`

## Field Summary

Fields
Modifier and Type
Field
Description
`protected JButton`
`charButton`
Button to initiate selecting special characters.
`protected SelectCharacters`
`charChooser`
The special character chooser.
`protected EventListenerList`
`listeners`
`protected JTextField`
`textField`
The text entry field.

### Fields inherited from class javax.swing.JComponent

`listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

### Fields inherited from class java.awt.Component

`accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

### Fields inherited from interface java.awt.image.ImageObserver

`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

## Constructor Summary

Constructors
Constructor
Description
`SelectTextField()`
Create an instance.
`SelectTextField(String text)`
Create an instance with initial text field.
`SelectTextField(String text, SelectCharacters charChooser)`
Create an instance with initial text field and using the pre-configured instance of SelectCharacters.

## Method Summary

Modifier and Type
Method
Description
`void`
`addActionListener(ActionListener l)`
Registers a listener who wants to be informed about changes to the character string.
`protected void`
`chooseChars()`
Choose a special character phrase to append.
`protected void`
`fireAction(ActionEvent e)`
Send action event to all listeners.
`Document`
`getDocument()`
Get the document model used by the JTextField.
`String`
`getText()`
Get the displayed text.
`Color`
`getTextColour()`
Get the text colour.
`Font`
`getTextFont()`
Get the text font.
`protected void`
`initUI()`
Initialise the user interface.
`void`
`insertText(String text)`
Insert new text, either at the end or at the insertion point.
`void`
`newCharacters(SelectCharactersEvent e)`
Accept new characters.
`void`
`removeActionListener(ActionListener l)`
`void`
`setColumns(int columns)`
Set the number of columns displayed by the JTextField.
`void`
`setText(String text)`
Set the displayed text.
`void`
`setTextColour(Color colour)`
Set the text colour.
`void`
`setTextFont(Font font)`
Set the text font.
`void`
`setToolTipText(String tip)`
Set the tooltip for the text component.

### Methods inherited from class javax.swing.JPanel

`getAccessibleContext, getUI, getUIClassID, paramString, setUI, updateUI`

### Methods inherited from class javax.swing.JComponent

`addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

### Methods inherited from class java.awt.Container

`add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`

### Methods inherited from class java.awt.Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocus, requestFocusInWindow, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setMixingCutoutShape, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Field Details

### textField

protected JTextField textField
The text entry field.

### charButton

protected JButton charButton
Button to initiate selecting special characters.

### charChooser

protected SelectCharacters charChooser
The special character chooser.

### listeners

protected EventListenerList listeners

## Constructor Details

### SelectTextField

public SelectTextField()
Create an instance.

### SelectTextField

public SelectTextField(String text)
Create an instance with initial text field.

Parameters:
  `text` - default text for the text field.

### SelectTextField

public SelectTextField(String text, SelectCharacters charChooser)
Create an instance with initial text field and using the pre-configured instance of SelectCharacters.

Parameters:
  `text` - default text for the text field.

## Method Details

### initUI

protected void initUI()
Initialise the user interface.

### chooseChars

protected void chooseChars()
Choose a special character phrase to append.

### newCharacters

public void newCharacters(SelectCharactersEvent e)
Accept new characters.

Specified by:
  `newCharacters` in interface `SelectCharactersListener`

### setText

public void setText(String text)
Set the displayed text.

### insertText

public void insertText(String text)
Insert new text, either at the end or at the insertion point.

### getText

public String getText()
Get the displayed text.

### setTextFont

public void setTextFont(Font font)
Set the text font.

### getTextFont

public Font getTextFont()
Get the text font.

### setTextColour

public void setTextColour(Color colour)
Set the text colour.

### getTextColour

public Color getTextColour()
Get the text colour.

### getDocument

public Document getDocument()
Get the document model used by the JTextField.

### setToolTipText

public void setToolTipText(String tip)
Set the tooltip for the text component.

Overrides:
  `setToolTipText` in class `JComponent`

### setColumns

public void setColumns(int columns)
Set the number of columns displayed by the JTextField.

### addActionListener

public void addActionListener(ActionListener l)
Registers a listener who wants to be informed about changes to the character string.

Parameters:
  `l` - the ActionListener

### removeActionListener

public void removeActionListener(ActionListener l)

### fireAction

protected void fireAction(ActionEvent e)
Send action event to all listeners.